// Stephen Toub

using System;
using System.IO;
using System.Windows.Markup;
using System.Windows.Controls;
using System.Windows.Forms.Integration;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Drawing;

namespace MsdnMag
{
    [PreviewHandler("MSDN Magazine XAML Preview Handler", ".xaml", "{7b7855e8-62d6-4887-8938-bfe1a11a62ce}")]
    [ProgId("MsdnMag.XamlPreviewHandler")]
    [Guid("dec9ca47-e4cd-4eed-8f1b-b0567a489f0a")]
    [ClassInterface(ClassInterfaceType.None)]
    [ComVisible(true)]
    public sealed class XamlPreviewHandler : StreamBasedPreviewHandler
    {
        protected override PreviewHandlerControl CreatePreviewHandlerControl()
        {
            return new XamlPreviewHandlerControl();
        }

        private sealed class XamlPreviewHandlerControl : StreamBasedPreviewHandlerControl
        {
            public override void Load(Stream stream)
            {
                // Load all of the XAML content into a frame
                Frame f = new Frame();
                XamlReader reader = new XamlReader();
                f.Content = reader.LoadAsync(stream);

                // Wrap the frame in an element host
                ElementHost xamlHost = new ElementHost();
                xamlHost.Child = f;
                xamlHost.Dock = DockStyle.Fill;
                xamlHost.BackColor = SystemColors.Window;

                Controls.Add(xamlHost);
            }
        }
    }
}